/* 
 RTL for codelets from MILEPOST project.

 Generated by Codelet Finder and updated by Grigori Fursin within EU FP6 MILEPOST project
 http://cTuning.org/lab/people/gfursin

 Agreed to be released by CAPS Entreprise as MILEPOST's deliverable.

 Updated by Grigori Fursin to support MILEPOST, cM and Collective Knowledge projects
*/

#ifdef __MINGW32__
#include <sys/time.h>
#else
#include <time.h>
#endif

#include <stdio.h>
#include <stdlib.h>

double timer_start, timer_length;
char* ck_time_file="tmp-ck-timer.json";

#ifdef WINDOWS
static clock_t start=0.0, stop=0.0;
#else 
static double start=0.0, stop=0.0;
static struct timeval  before, after, acc_before, acc_after;
#endif
static double secs;

static void start_clock()
{

#ifdef WINDOWS
  start = clock();
#else
  gettimeofday(&before, NULL);
#endif
}

static void stop_clock()
{
#ifdef WINDOWS
  stop = clock();
  secs = ((double)(stop - start)) / CLOCKS_PER_SEC;
#else
  gettimeofday(&after, NULL);
  secs = (after.tv_sec - before.tv_sec) + (after.tv_usec - before.tv_usec)/1000000.0;
#endif
}

int __astex_write_message(const char * format, ...)
{
}

int __astex_write_output(const char * format, ...)
{
}

void __astex_exit_on_error(const char * msg, int code, const char * additional_msg)
{
 printf("Error: %s (%u) %s\n", msg, code, additional_msg);
 exit(1);
}

void * __astex_fopen(const char * name, const char * mode)
{
  FILE* f;
  f=fopen(name, mode);
  if (f==NULL)
  {
    printf("Error: can't open file %s\n", name);
    exit(1);
  }

  return f;
}

void * __astex_memalloc(long bytes)
{
 void* b;

 b=malloc(bytes);

 if (b==NULL)
 {
   printf("Error: can't allocate memory\n");
   exit(1);
 }

 return b;
}

void __astex_close_file(void * file)
{
 fclose(file);
}

void __astex_read_from_file(void * dest, long bytes, void * file)
{
 fread(dest, 1, bytes, file);
}

int __astex_getenv_int(const char * var)
{
 char* p;
 int r=1;

 p=getenv(var);
 if (p!=NULL) r=atoi(p);

 return r;
}

void * __astex_start_measure()
{
 printf("Start codelet\n");
 start_clock();
}

double __astex_stop_measure(void * _before)
{
  FILE* f;

  stop_clock();

  printf("Stop codelet\n");

  f=fopen(ck_time_file, "w");
  if (f==NULL)
  {
    printf("Error: can't open timer file %s for writing\n", ck_time_file);
    exit(1);
  }

  fprintf(f,"{\n");
  fprintf(f,"  \"execution_time\":%.6lf,\n", secs);
  fprintf(f,"  \"execution_time_kernel_0\":%.6lf\n", secs);
  fprintf(f,"}\n");


  fclose(f);

  return timer_length;
}
